#pragma once

#ifndef _MiscHelper_H
#define _MiscHelper_H

#include "MathCommon.h"
#include "ModelFunction.h"

namespace MiscHelper {	

	void CalculateLogZ(
		const unsigned dim, 
		const OneDDataSet& splineTable, 
		const std::vector<QPoint>& quadraturePointList, 
		const unsigned numberWindw, 
		std::vector<double>& logZ,
		double& xAve,
		const double sps=0.0);

	double CalculateSplineSummation(
		const unsigned dim, 
		const OneDDataSet& splineTable, 
		const std::vector<SplineNode>& splineNodes,
		const bool useBaye=false);

	void CalculateProbability(
		const NDDataSet& x,
		const OneDDataSet& U,
		const std::vector<bool>& mask,
		const double ptot,
		const double lambda,
		OneDDataSet& prob,
		double& xAve,
		double& variance,
		double& divergence);

};


#endif // _MiscHelper_H
