// CommandLineManager.h: interface for the CommandLineManager class.
//
//
//
//////////////////////////////////////////////////////////////////////

#ifndef _CommandLineManager_H
#define _CommandLineManager_H

#include <string>
#include <vector>

class CommandLineManager  
{
public:

	typedef std::pair<std::string, std::string> KeyPair;
	
	virtual ~CommandLineManager();

	bool GetValue(const std::string& key, std::string& value) const;
	bool GetValue(const std::string& key, int& value) const;
	bool GetValue(const std::string& key, unsigned& value) const;
	bool GetValue(const std::string& key, double& value) const;
	bool GetFileName(const std::string& key, std::string& value) const; 
	bool GetKey(const std::string& key) const;
	void PrintOutHelpMessage(const bool extra=false);

protected:

	virtual void CreateHelpMessage()=0;
	void AddHelpMessage(const std::string& key, const std::string& value);
	void AddHelpMessageX(const std::string& key, const std::string& value);
	void Initialize(int numberArg, char* arg[]);

private:

	std::vector<KeyPair> m_keyList;
	std::vector<KeyPair> m_helpMessage;
	std::vector<KeyPair> m_helpMessageX;

};

#endif // // !defined(AFX_CommandLineManager_H__CB6B9FD7_BF49_4588_9743_36764E05B87F__INCLUDED_)
