// Output.h: interface for the Output class.
//
//
//
//////////////////////////////////////////////////////////////////////

#ifndef _Output_H
#define _Output_H

#include <sstream>
#include <string>
#include <vector>

class Output  
{
public:

	static Output& Instance();
	virtual ~Output();

	void Initialize();
	void AddValue(const std::string& key, const std::string& value, bool addTimeStamp=false);
	void AddValue(const std::string& key, const std::stringstream& value, bool addTimeStamp=false);

	void SetFileName(const std::string& key, const std::string& fileName);	

	//  Printout to the screen or to the default file for the specified key
	//  Printout a piece of info
	void PrintOut(const std::string& key, const std::string& info, const bool overwrite=false);
	//  Printout everything assoicated with the key
	void PrintOut(const std::string& key, const bool overwrite=false);

private:
	
	struct entry {
		std::string key;
		std::string value;
		std::string filename;
		entry(const std::string& k, const std::string& v):
		key(k), value(v), filename("") {};
		entry(const std::string& k, const std::string& v, const std::string& f):
		key(k), value(v), filename(f) {};
	};

	int FindKey(const std::string& key);

	std::vector<entry> m_keyList;
	
	Output();
};

#endif // // !defined(AFX_Output_H__CB6B9FD7_BF49_4588_9743_36764E05B87F__INCLUDED_)
