// CommandLineManager.cpp: implementation of the CommandLineManager class.
//
//////////////////////////////////////////////////////////////////////
#include <iostream>
#include <cstdlib>

#include "../include/CommandLineManager.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

namespace CommandLineManager_Impl{
	
	void PrintMessage(const std::vector<CommandLineManager::KeyPair>& input){

	unsigned size=input.size();
	std::string message("");
	for (unsigned i=0; i<size; i++){
		if (input[i].second.size()==0){
			message.append(input[i].first);
			message.append("\n");
		} else {
			message.append("\t");
			message.append(input[i].first);
			message.append(" : ");
			message.append(input[i].second);
			message.append("\n");
		}
	}

	std::cout<<message.c_str()<<std::endl;
	}
}
using namespace CommandLineManager_Impl;


CommandLineManager::~CommandLineManager()
{

}



void CommandLineManager::Initialize(int numberArg, char* arg[])
{
	m_helpMessage.clear();
	m_helpMessageX.clear();
	CreateHelpMessage();	

	int counter=0;
	for (int i=0; i<numberArg; i++){
		if (arg[i][0]=='-' && i<numberArg){
			std::string key=arg[i];		
			key.erase(key.begin());
			std::string value;
			if (i<(numberArg-1)) value=arg[i+1];
			KeyPair thisPair(key,value);
			m_keyList.push_back(thisPair);
		}		
	}

}

bool CommandLineManager::GetValue(const std::string& key, std::string& value) const
{

	bool result=false;
	for (unsigned int i=0; i<m_keyList.size(); ++i){
		if (key==m_keyList[i].first){
			value=m_keyList[i].second;
			result=true;
			break;
		}
	}
	
	return result;
			
}

bool CommandLineManager::GetValue(const std::string& key, int& value) const
{

	bool result=false;
	for (unsigned int i=0; i<m_keyList.size(); ++i){
		if (key==m_keyList[i].first){
			value=atoi(m_keyList[i].second.c_str());
			result=true;
			break;
		}
	}
	
	return result;
			
}

bool CommandLineManager::GetValue(const std::string& key, unsigned& value) const
{

	bool result=false;
	for (unsigned int i=0; i<m_keyList.size(); ++i){
		if (key==m_keyList[i].first){
			value=atoi(m_keyList[i].second.c_str());
			result=true;
			break;
		}
	}
	
	return result;
			
}


bool CommandLineManager::GetValue(const std::string& key, double& value) const
{

	bool result=false;
	for (unsigned int i=0; i<m_keyList.size(); ++i){
		if (key==m_keyList[i].first){
			value=atof(m_keyList[i].second.c_str());
			result=true;
			break;
		}
	}
	
	return result;
			
}


bool CommandLineManager::GetFileName(const std::string& key, std::string& value) const
{

	bool result=false;
	if (GetValue(key, value)){
		if (value[0]!='-') result=true;
	}
	return result;
}
bool CommandLineManager::GetKey(const std::string& key) const
{
	bool result=false;
	for (unsigned int i=0; i<m_keyList.size(); ++i){
		if (key==m_keyList[i].first){
			result=true;
			break;
		}
	}
	
	return result;
}

void CommandLineManager::AddHelpMessage(const std::string& key, const std::string& message){

	m_helpMessage.push_back(KeyPair(key, message));
}

void CommandLineManager::AddHelpMessageX(const std::string& key, const std::string& message){

	m_helpMessageX.push_back(KeyPair(key, message));
}

void CommandLineManager::PrintOutHelpMessage(const bool extra){

	PrintMessage(m_helpMessage);
	if (extra) PrintMessage(m_helpMessageX);
}

