// FileReader.cpp: implementation of the FileReader class.
//
//////////////////////////////////////////////////////////////////////
#include <cstdio> 
#include <stdexcept>
#include <vector>

#include "../include/FileReader.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

FileReader::FileReader(const std::string& fileName, const std::string& hint):
 m_fileName(fileName), m_hint(hint), m_contains("")
{

	ReadFile();
}

FileReader::~FileReader()
{

}

const std::string& FileReader::GetContains(){

	return m_contains;

}

void FileReader::ReadFile(){

	try {
		FILE* stream=fopen(m_fileName.c_str(),"rb");
		
		if (!stream){ 
			std::string error="**** Problem with openning the file: ";
			error.append(m_fileName);
			error.append("\n\n");		
			std::runtime_error e(error.c_str());
			throw e;

		} else {

			m_contains="";
			//
			// Store the output file to tmpFile
			// Here the 256KB setting is used to improve the performance and not to 
			// use too much memory
			//
			const int maxLenOnce=262144;			 
			char* tmpline= new char [maxLenOnce];
			int len=0;			
			int lenOnce;
			do { 
				lenOnce=fread(tmpline,1,maxLenOnce,stream);
				len+=lenOnce;
				m_contains.append(tmpline,lenOnce);
			} while(lenOnce==maxLenOnce);
			
			delete [] tmpline;
			fclose (stream);
		} 

	}  catch (...){
		throw;
	}
}
