#include "../include/Periodicity.h"
#include "../include/CommandLineManager.h"

Periodicity::Periodicity(void)
{

}

Periodicity::~Periodicity(void)
{
}

Periodicity& Periodicity::Instance(){

	static Periodicity thisInstance;
	return thisInstance;

}


void Periodicity::Initial(CommandLineManager* manager){

	bool has2ndDimension=false;
	const double buffer1D=0.25, buffer2D=0.1;
	m_conditions.resize(2, PeriodicalCondition());

	if (manager->GetKey("r") || manager->GetKey("r2")){
		double min=1e10, max=-1e10, buffer=buffer2D;
		if (manager->GetValue("y",min)){
			if (manager->GetValue("Y",max)){
				if (manager->GetKey("rb2")) manager->GetValue("rb2", buffer);
				if (min<max){
					m_conditions[1]=PeriodicalCondition(min, max, buffer);
					has2ndDimension=true;
				}
			}
		} 
	}

	if (manager->GetKey("r") || manager->GetKey("r1")){
		double min=1e10, max=-1e10, buffer=buffer1D;
		if (manager->GetValue("x",min)){
			if (manager->GetValue("X",max)){
				if (has2ndDimension) buffer=buffer2D;
				if (manager->GetKey("rb1")) manager->GetValue("rb1", buffer);
				if (min<max)m_conditions[0]=PeriodicalCondition(min, max, buffer);
			}
		} 
	}
}
