#include <fstream>
#include <iostream>
#include <ctime>
#include <assert.h>

#include "../include/SignalHandler.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SignalHandler::~SignalHandler()
{

	m_signalList.clear();
}

SignalHandler& SignalHandler::Instance(){

	static SignalHandler thisInstance;
	return thisInstance;

}

SignalHandler::SignalHandler()
{

}

int SignalHandler::RegisterSignal(const int sig){

	bool found=false;
	int index=-1;
	for (unsigned i=0; i<m_signalList.size(); i++){
		if (m_signalList[i].first==sig) {
			found=true;
			index=i;
			break;
		}
	}

	if (!found){
		m_signalList.push_back(std::pair<int, bool>(sig, false));
		index=m_signalList.size()-1;
	}

	return index;
}

bool SignalHandler::CheckSignal(const int sig){

	bool result=false;
	for (unsigned i=0; i<m_signalList.size(); i++){
		if (m_signalList[i].first==sig) {
			result=m_signalList[i].second;
			break;
		}
	}

	return result;
}

void SignalHandler::SetSignal(const int sig, const bool set){

	int index=RegisterSignal(sig);

	assert(m_signalList[index].first==sig);
	m_signalList[index].second=set;

}