#pragma once

#ifndef _BEDAMMLEFinder_H
#define _BEDAMMLEFinder_H

#include "Common.h"
#include "MathTools/include/ModelFunction.h"
#include "MLEFinder.h"


class BEDAMMLEFinder: public MLEFinder
{
public:

	BEDAMMLEFinder(WindowSet* pSet, const OneDDataSet& lambda)
		: MLEFinder(pSet, false), m_lambda(lambda){};

	~BEDAMMLEFinder(void) {};
	virtual double FunctionValue (const OneDDataSet& arg);

	virtual OneDDataSet Derivative(const OneDDataSet& arg) const;
	
protected:

	virtual void OutputResults(const std::vector<double>& parameter);

private:

	BEDAMMLEFinder(void);
	BEDAMMLEFinder(const BEDAMMLEFinder&);

	OneDDataSet m_lambda;
};


#endif // _BEDAMMLEFinder_H
