#pragma once

#ifndef _BEDAMSetDecorator_H
#define _BEDAMSetDecorator_H

#include <vector>
#include "SetDecorator.h"

class BEDAMSetDecorator :public SetDecorator {

public:

	enum MLEMethod {global, derivative};

	static void Derivative(const NDDataSet& xData, OneDDataSet& U, void* pSet);
	static void GlobalMLEFit(const NDDataSet& xData, OneDDataSet& U, void* pSet);

	BEDAMSetDecorator(boost::shared_ptr<WindowSet> pSet);

	virtual ~BEDAMSetDecorator(void);

	virtual void SetupOptions();
	virtual void PerformAnalysis();

private:

	BEDAMSetDecorator::MLEMethod m_currentMethod;

};

#endif // _BEDAMSetDecorator_H
