#include <algorithm>
#include <math.h>

#include "Utils/include/FileReader.h"
#include "Utils/include/StringParser.h"
#include "MathTools/include/PhysicalConstants.h"
#include "MathTools/include/StatTools.h"
#include "BEDAMWindow.h"


BEDAMWindow::BEDAMWindow(const double lambda, const NDDataSet& rawData)
: m_lambda(lambda){
	
	DoStat();
}


BEDAMWindow::~BEDAMWindow(void)
{
}

bool BEDAMWindow::TestData()
{
	unsigned numberDataPoint=GetRawData().size();
	unsigned numberDimension=0;
	const NDDataSet& positions = GetRawData(); 
	if (numberDataPoint>0) numberDimension=positions[0].size();

	std::vector<double> temp(numberDataPoint,0.0);
	return (numberDimension>0 && numberDataPoint >0 );
}

void BEDAMWindow::DoStat(){

	const NDDataSet& positions = GetRawData(); 
	unsigned numberDataPoint=positions.size();

	unsigned numberDimension=GetDimensionality();
	m_observed.resize(numberDimension);

	OneDDataSet temp(numberDataPoint, 0.0);
	for (unsigned i=0; i<numberDimension; i++){

		for (unsigned j=0; j<numberDataPoint; j++) temp[j]=positions[j][i];
		
		NormalDistribution<double> stat(temp);
		m_observed[i].mean=stat.GetMean();
		m_observed[i].variance=stat.GetVariance();
	}

}
