#pragma once

#ifndef _BEDAMWindow_H
#define _BEDAMWindow_H

#include "MathTools/include/MathCommon.h"
#include "DataWindow.h"

class BEDAMWindowSet;
class BEDAMSetDecorator;

class BEDAMWindow: public DataWindow
{

	friend class BEDAMWindowSet;
	friend class BEDAMSetDecorator;

	const double GetLambda () const{ return m_lambda; };

protected:

	virtual ~BEDAMWindow(void);
	BEDAMWindow(const double lambda, const NDDataSet& rawData);

	const GuassianDistributionSet& GetObserved() const { return m_observed; };

	virtual bool TestData();
	virtual void DoStat();
	virtual void PrintDataInfo(){};
	
private:

	BEDAMWindow();
	GuassianDistributionSet m_observed;

	double m_lambda;
	
};

#endif //
