#pragma once

#ifndef _DiscretePrior_H
#define _DiscretePrior_H

#include "Prior.h"

#include <iostream>
#include <string>

class DiscretePrior: public Prior {

public:

	DiscretePrior(const double weight=0.01);
	DiscretePrior(const NDDataSet& positions, const OneDDataSet& values, const double weight=1.0);
	virtual ~DiscretePrior(void);

	virtual double GetZIntegral(const NDDataSet& currentNodePositions, const OneDDataSet& currentSplineTable) const;
	virtual double CalculatePriorAverage(const NDDataSet& currentNodePositions, const OneDDataSet& currentSplineTable) const;

private:

	virtual void Init();

	NDDataSet m_dataPositions;
};


#endif // _SplineFileHandler_H
