#pragma once

#ifndef _Prior_H
#define _Prior_H

#include "MathTools/include/MathCommon.h"

#include <iostream>
#include <string>

class Prior {

public:

	enum PriorType  { spline, discrete };

	Prior(const double weight=1.0);
	Prior(const NDDataSet& positions, const OneDDataSet& values, const double weight=1.0);
	virtual ~Prior(void);

	const double GetWeight() const { return m_weight; };

	virtual double GetZIntegral(const NDDataSet& currentNodePositions, const OneDDataSet& currentSplineTable) const = 0;
	virtual double CalculatePriorAverage(const NDDataSet& currentNodePositions, const OneDDataSet& currentSplineTable) const = 0;

protected:

	virtual void Init()=0;
	
	NDDataSet m_nodePositions;
	OneDDataSet m_values;
	double m_weight;
	double m_temp;

};


#endif // _SplineFileHandler_H
