#include <boost/shared_ptr.hpp>
#include "SetDecoratorFactory.h"

#include "USSetDecorator.h"
#include "BEDAMSetDecorator.h"

SetDecoratorFactory& SetDecoratorFactory::Instance() { 

	static SetDecoratorFactory instance;
	return instance;
}	

boost::shared_ptr<SetDecorator> SetDecoratorFactory::CreateSetDecorator(boost::shared_ptr<WindowSet> pSet, WindowDataType::Type type){

	boost::shared_ptr<SetDecorator> pDecorator;  //TL: change to a smart point later
	switch (type){
		case WindowDataType::UmbrellaSampling: default:
			pDecorator=boost::shared_ptr<SetDecorator>(new USSetDecorator(pSet));
			break;
		case WindowDataType::BEDAM:
			pDecorator=boost::shared_ptr<SetDecorator>(new BEDAMSetDecorator(pSet));
			break;
	}

	return pDecorator;
}
