#pragma once

#ifndef _SplinePrior_H
#define _SplinePrior_H

#include "Prior.h"

#include <iostream>
#include <string>

class SplinePrior: public Prior {

public:

	SplinePrior(const double weight=0.01);
	SplinePrior(const NDDataSet& nodePositions, const OneDDataSet& values, const double weight=1.0);
	virtual ~SplinePrior(void);

	virtual double GetZIntegral(const NDDataSet& currentPositions, const OneDDataSet& currentSplineTable) const;
	virtual double CalculatePriorAverage(const NDDataSet& currentPositions, const OneDDataSet& currentSplineTable) const;

private:

	virtual void Init();

	bool m_backgroundOnly;
	std::vector<QPoint> m_quadraturePointList;
	OneDDataSet m_SplinePriorTable;

};


#endif // _SplineFileHandler_H
