#pragma once
#ifndef _USSetDecorator_H
#define _USSetDecorator_H

#include "SetDecorator.h"

class WindowSet;

class USSetDecorator :public SetDecorator
{
public:

	enum PMFMethod {Derivative, Wham, MLE};
	enum InterporationMethod {Cubic, Rational};

	static void CalculateCombinedDerivative(const NDDataSet& xData, OneDDataSet& U, void* pSet);
	static void CalculateWhamPMF(const NDDataSet & xData, OneDDataSet& U, void* pSet);
	static void CalculateMLEPMF(const NDDataSet& xData, OneDDataSet& U, void* pSet);

	USSetDecorator(boost::shared_ptr<WindowSet> pSet);
	virtual ~USSetDecorator(void);

	virtual void SetupOptions();
	virtual void PerformAnalysis();

private:

	// Internal routines
	void GetGridRange(NDData& xmin, NDData& xmax, NDInt& numberGrid, NDInt& totalGrid, NDInt& padNumberGrid);

	// Data
	USSetDecorator::PMFMethod m_PMFMethod;
	USSetDecorator::InterporationMethod m_InterporationMethod;

};

#endif // _USSetDecorator_H
