#include "vFEPCommandManager.h"
#include "WindowSetFactory.h"

#include "USWindowSet.h"
#include "BEDAMWindowSet.h"



WindowSetFactory& WindowSetFactory::Instance() { 

	static WindowSetFactory instance;

	return instance;
}	

boost::shared_ptr<WindowSet> WindowSetFactory::CreateWindowSet(const std::string& fileName, WindowDataType::Type type, const double temp){

// Sampling frequency
	int dataFreq=1;
	if (vFEPCommandManager::Instance().GetValue("s",dataFreq)){
		if (dataFreq==0 || dataFreq==-1) dataFreq=1;
	}

	boost::shared_ptr<WindowSet> pSet;  //TL: change to a smart point later
	switch (type){
		case WindowDataType::UmbrellaSampling: default:
			pSet=boost::shared_ptr<WindowSet>(new USWindowSet(fileName, dataFreq));
			break;
		case WindowDataType::BEDAM:
			pSet=boost::shared_ptr<WindowSet>(new BEDAMWindowSet(fileName, dataFreq));
			break;
	}

	pSet->SetTemperature(temp);

	return pSet;
}
