#pragma once

#ifndef _WindowSetFactory_H
#define _WindowSetFactory_H

#include <string>
#include <boost/shared_ptr.hpp>
#include "WindowDataType.h"

class WindowSet;


class WindowSetFactory
{
public:

	static WindowSetFactory& Instance();
	boost::shared_ptr<WindowSet> CreateWindowSet(const std::string& fileName, WindowDataType::Type type, const double temp);

private:

	WindowSetFactory(){};
	virtual ~WindowSetFactory(){};

};

#endif // _WindowSetFactory_H
